package com.fdkankan.platform.user.factory.impl;

import com.alibaba.fastjson.JSONObject;
import com.fdkankan.common.constant.Constant;
import com.fdkankan.common.constant.ErrorCode;
import com.fdkankan.common.exception.BusinessException;
import com.fdkankan.pay.paypal.PayPalDefaultConfig;
import com.fdkankan.platform.order.entity.CommerceOrder;
import com.fdkankan.platform.order.request.RequestPlaceOrder;
import com.fdkankan.platform.order.service.ICommerceOrderService;
import com.fdkankan.platform.order.service.PayOrderService;
import com.fdkankan.platform.user.factory.Commerce;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

@Component
public class PaypalCommerce implements Commerce {

    @Autowired
    private PayOrderService payOrderService;
    @Autowired
    private ICommerceOrderService commerceOrderService;
    @Autowired
    private PayPalDefaultConfig payPalDefaultConfig;

    @Value("${main.url}")
    private String mainUrl;

    @Override
    public JSONObject scanPay(RequestPlaceOrder order) throws Exception {
        return getResult(order, mainUrl + payPalDefaultConfig.getPaySuccessUrl(), mainUrl + payPalDefaultConfig.getCancelUrl());
    }

    @Override
    public JSONObject h5Pay(RequestPlaceOrder order, String ip) throws Exception {
        return getResult(order, mainUrl + payPalDefaultConfig.getH5PaySuccessUrl(), mainUrl + payPalDefaultConfig.getH5CancelUrl());
    }

    private JSONObject getResult(RequestPlaceOrder order, String successUrl, String cancelUrl) throws Exception {
        CommerceOrder commerce = commerceOrderService.getById(order.getOrderId());
        if (commerce == null) {
            throw new BusinessException(ErrorCode.FAILURE_CODE_8001);
        }
        String subject = Constant.COMMERCE_SUBJECT;
        String orderSn = commerce.getOrderSn();
        orderSn += "_commerce";
        return payOrderService.payPalPay(orderSn, subject, subject, commerce.getAmount(), commerce.getAmount(),
                successUrl,
                cancelUrl);
    }

    @Override
    public String getType() {
        return "paypal_3";
    }
}
